                                                          (* 14.3.1997    *)
(* Alias: Parabel = Einhuellende durch Tangentenschar *)
{$N+}
PROGRAM Parab1;
USES CRT,GRAPH,UNIGRA12;

CONST
Eps = 1.0E-12;

TYPE
Line2D = RECORD                                                     
             O: Pt2D;
             U: Vt2D;
           END;

VAR
T1,T2       : EXTENDED;                  (* Parameter der Geraden =       *)
                                         (* Loesungen der quadr. Gleich.  *)
                                      (* Dreieckspunkte                   *)
F,M         : Pt2D;                                 (* Brennpunkt  *)
T,LLine     : Line2D;
AC,AB,BC                    : Line2D;                   
Intsec                      : Boolean;
 
  P1,P2,P133 : Pt2D;
{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN
   IF PLOT THEN Plotter_einschalten;
   WinitGraph(0,0,'');
   Weltgrenzen_festlegen(einh);
   Viewport_festlegen;

   IF PLOT THEN GeraetefensterPlotter_festlegen;
   Parameter2D;
   IF PLOT THEN Portrait  := FALSE;        (* Querformat Bild liegend      *)
   IF PLOT THEN WRITE(AUX,'WU0');          (* width unit absolut in mm     *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;

   Viewport_zeichnen; 
  { Koordinatenachsen_zeichnen;
   Gitter(0.3,2.0,10.0);}(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung;
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS: STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];

  
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(Einh:5:3,EinhS);
  
  
(* ----------------------------- TEXTE --------------------------------- *)
  
  Ttemp1 := ' ';
  Ttemp2 := '';
  T[1] := Ttemp1 + Ttemp2;
  T[2] := '';
  Ttemp1 := '';
  Ttemp2 := '';
  T[3] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[4] := Ttemp1 + Ttemp2;
  T[5] := '1 Einheit entspricht '+EinhS+'  cm';
  Text_ausgeben(T,5);                                 (* .. Texte ausgeben *)
  END;

PROCEDURE MidPoint(P1,P2: Pt2D; VAR M: Pt2D);
   BEGIN
     M.X := (P1.X+P2.X)/2.0;
     M.Y := (P1.Y+P2.Y)/2.0;
   END;

PROCEDURE MakeVt2D(P1,P2: Pt2D; VAR V: Vt2D);
  BEGIN
   V.X := P2.X - P1.X;
   V.Y := P2.Y - P1.Y;
  END;

PROCEDURE NormalVector(V: Vt2D; VAR NV : Vt2D);
  BEGIN
    NV.X := -V.Y;
    NV.Y :=  V.X;
  END;
   
PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

PROCEDURE ScaleVt2D(V: Vt2D; LG: EXTENDED; VAR ScalV: Vt2D);
VAR L: EXTENDED;
BEGIN
  ScalV:=V;
  LengthVt2D(V, L);
  IF NOT Null(L,Eps) THEN BEGIN
    ScalV.X:=V.X/L*LG;
    ScalV.Y:=V.Y/L*LG;
  END;
END;

PROCEDURE MakeLine2D(P1,P2: Pt2D; VAR Line: Line2D);
  VAR
  hv : Vt2D;
  BEGIN
    MakeVt2D(P1,P2,hv);
    ScaleVt2D(hv,1.0,hv);
    Line.O := P1;
    Line.U := hv;
  END;

PROCEDURE SumVt2d(V1,V2:Vt2D; VAR V: Vt2D);
  BEGIN
   V.X := V1.X+V2.X;
   V.Y := V1.Y+V2.Y;
  END;

PROCEDURE DifferenceVt2D(V1,V2: Vt2D; VAR DV: Vt2D);
BEGIN
  DV.X := V1.X-V2.X;
  DV.Y := V1.Y-V2.Y;
END;

PROCEDURE LinearCombinationVt2D(S1,S2: EXTENDED; V1,V2: Vt2D; VAR LC: Vt2D);
BEGIN
  LC.X:=S1*V1.X+S2*V2.X;
  LC.Y:=S1*V1.Y+S2*V2.Y;
END;

PROCEDURE ScalarProductVt2D(V1,V2: Vt2D; VAR SP: EXTENDED);
BEGIN
  SP:=V1.X*V2.X+V1.Y*V2.Y;
END;

PROCEDURE TToLine2D(Ln2D: Line2D; T: EXTENDED; VAR P: Pt2D);
BEGIN
  LinearCombinationVt2D(1,T,Ln2D.O,Ln2D.U, P);
END;

PROCEDURE IntersectionLines2D(Line1,Line2: Line2D; VAR Intsec: BOOLEAN;
                              VAR T1,T2: EXTENDED; VAR S: Pt2D);
VAR Num,Den: EXTENDED;
    N2,DV: Vt2D;
    V: Vt2D;
BEGIN
  Intsec := FALSE;
  N2.X := Line2.U.Y; N2.Y := -Line2.U.X;
  DifferenceVt2D(Line1.O, Line2.O, DV);
  ScalarProductVt2D(DV,N2, Num);
  ScalarProductVt2D(Line1.U,N2, Den);
  IF NOT Null(Den,Eps) THEN BEGIN
    T1 := -Num/Den;
    TToLine2D(Line1,T1, S);
    DifferenceVt2D(S,Line2.O, V);       (* nicht mehr notwendig, nur mehr *)
    ScalarProductVt2D(V,Line2.U, T2);   (* zur Berechnung von t2          *)
    Intsec := TRUE;
  END;
END;

PROCEDURE NormLinie;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL');              (* 6.:                        *)
               WRITE(AUX,'PW0.15');          (* 0.15 mm                    *)
               WRITE(AUX,'LT');              (* solid                      *)
    END;
  SetLineStyle(0,0,1);
  END;

PROCEDURE Hilfslinie1;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,1,9,1,9,1,9');  (* 1.:                       *)
               WRITE(AUX,'PW0');              (* ganz schwache Hilfslinie: *)
               WRITE(AUX,'LT8,4.0,1');       
    END;
    SetLineStyle(4,$8080,1);
  END;

PROCEDURE HilfsLinie2;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,2,7,2,7,2,7');  (* 2.:                       *)
               WRITE(AUX,'PW0');              (* staerkere Hilfslinie      *)
               WRITE(AUX,'LT8,2.0,1');      
    END;
    SetLineStyle(1,0,1);
  END;

PROCEDURE WeitStrichliert;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,7,4,7,4,7,4'); (* 3.:                        *)
               WRITE(AUX,'PW0');             (* duennste Linie strichliert *)
               WRITE(AUX,'LT8,7.0,1');       (*  weite Abstaende           *)
    END;
    SetLineStyle(4,$FF00,1);
  END;

PROCEDURE EngStrichliert;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL8,7,2,7,2,7,2'); (* 5.:                        *) 
               WRITE(AUX,'PW0');             (* strichliert enge Abstaende *)
               WRITE(AUX,'LT8,10.0,1');
    END;
    SetLineStyle(3,0,1);
  END;

PROCEDURE StrichPunktiert;                   (* als Symmetrieachse         *)
  BEGIN
    IF PLOT THEN BEGIN WRITE(AUX,'UL8,8,2,2,2,8,2,2,2,8,2,2,2'); 
               WRITE(AUX,'PW0');             (* duennste Linie             *)
               WRITE(AUX,'LT8,15.0,1');      (* strichpunktiert mit klein. *)
    END;                                     (* Strich als Punkt           *)
    SetLineStyle(4,$F18F,1);                  
  END;                                           

PROCEDURE BreitLinie;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL');              (* 7.:                        *)
               WRITE(AUX,'PW0.3');           (* 0.3 durchgehend            *)
               WRITE(AUX,'LT');
    END;
    SetLineStyle(0,0,1);
  END;
   
(* -------------------- eigentliche Routinen ----------------------------- *)

PROCEDURE Eingabe;                
  BEGIN                         
   F.X :=   5.0;  F.Y :=   0.0;                       
   LLine.O.X := -1.0; LLine.O.Y := 0.0; LLine.U.X := 0.0; LLine.U.Y := 1.0;
  END;

PROCEDURE Zeichnen;
  BEGIN                                                 
  Normlinie;
  DrawLine2D(P1,P2,7);
END;

PROCEDURE Parabeltangente;
   VAR
   Param : EXTENDED;
   HV : Vt2D;
   BEGIN
   Param := -90.0;
     WHILE Param < 90.0 DO BEGIN
     TToLine2D(LLine, Param,P133);
     MidPoint(P133,F,M);
     MakeVt2D(P133,F,HV);
     ScaleVt2D(HV,1.0,HV);
     NormalVector(HV,T.U);
     T.O := M;
     TToLine2D(T, -90.0,P1);  TToLine2D(T,90.0,P2);
     Zeichnen;
     Param := Param + 1.0;
     END;
   END;



{ --------------------------- Hauptprogramm ------------------------------- }
BEGIN
  Plot := FALSE;
  IF PLOT THEN Schnittstelle_waehlen(1);   (* 2 bedeutet auf Datei plotten *)
                                           (* 1 ist parallele Schnittst    *)
                 (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  Einh := 0.5;
  WI2D[1].X := -20.0;  WI2D[1].Y := -20.0;
                                               (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)

  Eingabe;
  Parabeltangente;

  {Beschriftung;}
  WClosegraph;
END.